# Emerald CaaS Framework Contribution Guidelines

This repository contains Contribution Guidelines for CaaS Framework in EMERALD project.
NOTE: These guidelines were written for the project team, and sometimes refer to private repositories not publicly accesible.

## Table of contents
  - [Table of contents](#table-of-contents)
  - [Description](#description)
  - [Usage](#usage)
  - [Support](#support)
  - [Roadmap](#roadmap)
  - [Contributing](#contributing)
  - [Authors and acknowledgment](#authors-and-acknowledgment)
  - [License](#license)
  - [Project status](#project-status)

## Description
This repository contains diferent utility guidelines on how to contribute to the Emerald CaaS Framework. The guidelines are divided into different sections, each one with a specific purpose.
- [Enroll](https://git.code.tecnalia.com/emerald/public/enroll/-/blob/master/README.md) how to join to the repository for contributions.
- [Component Development](./component_development.md): Contains the guidelines for developing a new component for the CaaS Framework.
- [Component Integration](./component_integration.md): Contains the guidelines for integrating a new component into the CaaS Framework.
- [Component Validation](./component_validation.md): Contains the guidelines for validating a new component for the CaaS Framework.
- [Keycloak Integration](./keycloak_integration.md): Contains the guidelines for integrating Keycloak into the components of the CaaS Framework.
- [Component Update](./component_update.md): Contains the guidelines for updating a component of the CaaS Framework.
- [Component Troubleshooting](./component_troubleshooting.md): Contains the guidelines for troubleshooting a component of the CaaS Framework.
- [Semantic Versioning with Gitlab CI/CD](./semantic_versioning_ci_cd.md): Contains the guidelines for versioning the components of the CaaS Framework.
- [Component Publish with Gitlab CI/CD](./component_publish_ci_cd.md): Contains the guidelines for setting up the CI/CD pipeline for a component image publishing in gitlab.

Version: 1.0.0

## Support
If you want to improve the guidelines, add an [issue](../../../-/issues) and contact the [Owners/Maintainers](../-/project_members?sort=access_level_desc) of the repo.


## Roadmap
No future plans for this project apart from improving the guidelines based on your feedback.

## Contributing
In order to contribute to the project, you can [fork](../../../-/forks/new) the repository and create a merge request. The merge request will be reviewed by the project maintainers and if it is accepted it will be merged into the main branch.

## Authors and acknowledgment
This project was developed by [Tecnalia](https://www.tecnalia.com/).

Thanks to:
- [makeareadme.com](https://www.makeareadme.com/#suggestions-for-a-good-readme) for this template.
- [Emerald Project](https://www.emerald-he.eu/) for resources and inspiration.
- [To be Continous](https://to-be-continuous.gitlab.io/doc/) for the CI/CD components.
- [Gitlab CI/CD](https://docs.gitlab.com/ee/ci/) for the CI/CD documentation.

## License
Read the [license file](../../../LICENSE) for more information.

## Project status
The project is in a stable state and is not actively being developed.