# Component Update

Components are normally updated to fix bugs, add new features, or improve performance. In this guide, we will show you different ways to updated your component.

There are two ways to update a component:
- Automatically by RenovateBot
- Manually

There may be situations where, apart from the component update, some configuration changes will be required. This will be explained in the last section.

## Table of contents
- [Automatically by RenovateBot](#automatically-by-renovatebot)
- [Manually](#manually)
- [Configuration changes](#configuration-changes)

## Automatically by RenovateBot
`RenovateBot` is a tool that helps you to keep your dependencies up to date. It will automatically create pull requests to update the dependencies of the components. It will periodically check the component versions in the docker image registry and create a pull request if a new version is available.

This procedure is transparent to the developers.

## Manually
This is required when the component does not use versioning. If you need to update a component manually, you can follow these steps:
1. Ensure the new version is available in the docker image registry.
2. Login into the [kubernetes cluster](https://k8so.emerald.digital.tecnalia.dev), and find the pod that uses the component you want to update.
3. Delete the pod. The pod will be recreated with the new version of the component.

## Configuration changes
Sometimes, when a component is updated, configuration changes are required. This is because the new version of the component may have new features or changes in the configuration. In this case, the component configuration files should be updated.

To do so, create an issue and a Merge Request (MR) in the [CaaS Framework repository](https://git.code.tecnalia.com/emerald/private/devops/caas-framework) with the changes required in the configuration files. The MR should be reviewed and merged by the CaaS Framework administrator.

In the case of automatic updates, it may happen that the component update fails and the MR is not merged. In this case, add the configuration changes to the MR and ask the CaaS Framework administrator to merge it.
